diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java
index d7679969a..a2cc78d2a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk.reader;
 
 import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.Registry;
 import net.minecraft.core.world.World;
@@ -185,7 +186,7 @@ public class ChunkReaderVersion1
     }
 
     @Override
-    public byte[] getBiomeMap(int ySection, Map<Integer, String> biomeRegistry)
+    public byte[] getBiomeMap(int ySection, Int2ObjectMap<String> biomeRegistry)
     {
         byte[] newBiomes = new byte[Chunk.CHUNK_SIZE_X * (ChunkSection.SECTION_SIZE_Y >> 3) * Chunk.CHUNK_SIZE_Z];
 
@@ -214,7 +215,7 @@ public class ChunkReaderVersion1
     }
 
     @Override
-    public Map<Integer, String> getBiomeRegistry() {
+    public Int2ObjectMap<String> getBiomeRegistry() {
         CompoundTag registriesTag = tag.getCompoundOrDefault("Registries", null);
         CompoundTag biomesTag = null;
         if (registriesTag != null)
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java
index 5c921eaa3..51b3725c3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.chunk.reader;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import com.mojang.nbt.tags.Tag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.Registry;
 import net.minecraft.core.world.World;
@@ -130,7 +131,7 @@ public class ChunkReaderVersion2
     }
 
     @Override
-    public byte[] getBiomeMap(int ySection, Map<Integer, String> biomeRegistry) {
+    public byte[] getBiomeMap(int ySection, Int2ObjectMap<String> biomeRegistry) {
         byte[] biomeMap = null;
         CompoundTag sectionTag = findSection(ySection);
         if (sectionTag != null) {
@@ -157,7 +158,7 @@ public class ChunkReaderVersion2
     }
 
     @Override
-    public Map<Integer, String> getBiomeRegistry() {
+    public Int2ObjectMap<String> getBiomeRegistry() {
         CompoundTag registriesTag = tag.getCompoundOrDefault("Registries", null);
         CompoundTag biomesTag = null;
         if (registriesTag != null)
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java
index 12295385a..951626226 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.world.config.season;
 
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.world.season.Season;
 
 import java.util.ArrayList;
-import java.util.HashMap;
 import java.util.List;
-import java.util.Map;
 
 public class SeasonConfigBuilder
 {
@@ -17,20 +17,20 @@ public class SeasonConfigBuilder
 
     private Type type = null;
     private List<Season> seasons = null;
-    private Map<Season, Integer> seasonLengthMap = null;
+    private Object2IntMap<Season> seasonLengthMap = null;
     private Season singleSeason = null;
 
     protected SeasonConfigBuilder() { }
 
     public SeasonConfig build()
     {
-        if (type == Type.SINGLE && singleSeason != null)
+        if (this.type == Type.SINGLE && this.singleSeason != null)
         {
-            return new SeasonConfigSingle(singleSeason);
+            return new SeasonConfigSingle(this.singleSeason);
         }
-        else if (type == Type.CYCLE && seasons != null && seasonLengthMap != null)
+        else if (this.type == Type.CYCLE && this.seasons != null && this.seasonLengthMap != null)
         {
-            return new SeasonConfigCycle(seasons, seasonLengthMap);
+            return new SeasonConfigCycle(this.seasons, this.seasonLengthMap);
         }
         else
         {
@@ -38,7 +38,7 @@ public class SeasonConfigBuilder
         }
     }
 
-    public SeasonConfigBuilder withSingleSeason(Season season)
+    public SeasonConfigBuilder withSingleSeason(final Season season)
     {
         this.type = Type.SINGLE;
         this.seasons = null;
@@ -48,12 +48,12 @@ public class SeasonConfigBuilder
         return this;
     }
 
-    public SeasonConfigBuilder withSeasonInCycle(Season season, int length)
+    public SeasonConfigBuilder withSeasonInCycle(final Season season, final int length)
     {
         this.type = Type.CYCLE;
         if (this.seasons == null) this.seasons = new ArrayList<>();
         this.seasons.add(season);
-        if (this.seasonLengthMap == null) this.seasonLengthMap = new HashMap<>();
+        if (this.seasonLengthMap == null) this.seasonLengthMap = new Object2IntArrayMap<>();
         this.seasonLengthMap.put(season, length);
         this.singleSeason = null;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigCycle.java b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigCycle.java
index 903d7c202..df3ebc7e5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigCycle.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigCycle.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.world.config.season;
 
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.world.season.Season;
 import org.jetbrains.annotations.NotNull;
 
@@ -10,12 +12,12 @@ public class SeasonConfigCycle
     extends SeasonConfig
 {
     private final List<Season> seasons;
-    private final SeasonMapInternal seasonLengthMap;
+    private final Object2IntArrayMap<Season> seasonLengthMap;
 
-    protected SeasonConfigCycle(List<Season> seasons, @NotNull Map<Season, Integer> seasonLengthMap)
+    protected SeasonConfigCycle(List<Season> seasons, @NotNull Object2IntMap<Season> seasonLengthMap)
     {
         this.seasons = seasons;
-        this.seasonLengthMap = new SeasonMapInternal(seasonLengthMap);
+        this.seasonLengthMap = new Object2IntArrayMap<>(seasonLengthMap);
     }
 
     public List<Season> getSeasons()
@@ -27,29 +29,4 @@ public class SeasonConfigCycle
     {
         return seasonLengthMap.getOrDefault(season, 0);
     }
-
-    private static class SeasonMapInternal { // Exists since seasonLengthMap.getOrDefault is slow for how often it can be called
-        private final Season[] seasons;
-        private final int[] lengths;
-        public SeasonMapInternal(final @NotNull Map<Season, Integer> seasonLengthMap) {
-            this.seasons = new Season[seasonLengthMap.size()];
-            this.lengths = new int[seasonLengthMap.size()];
-
-            int i = 0;
-            for (final Map.Entry<Season, Integer> entry : seasonLengthMap.entrySet()) {
-                this.seasons[i] = entry.getKey();
-                this.lengths[i] = entry.getValue();
-                i++;
-            }
-        }
-
-        public int getOrDefault(final Season season, final int defaultValue) {
-            for (int i = 0; i < this.seasons.length; i++) {
-                if (this.seasons[i].equals(season)) {
-                    return this.lengths[i];
-                }
-            }
-            return defaultValue;
-        }
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java b/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
index 6291b81c6..07c3243ab 100644
--- a/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
@@ -1,6 +1,10 @@
 package net.minecraft.core.world.data;
 
 import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
@@ -35,8 +39,8 @@ public class SynchedEntityData
     public static final int MAX_STRING_SIZE = 1024;
 
     public static final int END_MARKER = 0xFF;
-    private static final HashMap<Class<?>, Integer> DATA_TYPES = new HashMap<>();
-    private final Map<Integer, @NotNull DataItem<?>> itemsById = new HashMap<>();
+    private static final Object2IntMap<Class<?>> DATA_TYPES = new Object2IntArrayMap<>();
+    private final Int2ObjectMap<@NotNull DataItem<?>> itemsById = new Int2ObjectArrayMap<>();
     private boolean isDirty = true;
 
     /**
@@ -48,8 +52,7 @@ public class SynchedEntityData
      */
     public <T> void define(int id, T value, Class<T> valueClass)
     {
-        Integer integer = DATA_TYPES.get(valueClass);
-        if(integer == null)
+        if(!DATA_TYPES.containsKey(valueClass))
         {
             throw new IllegalArgumentException("Unknown data type: " + valueClass);
         }
@@ -67,7 +70,7 @@ public class SynchedEntityData
         }
         else
         {
-            DataItem<T> item = new DataItem<>(integer, id, value);
+            DataItem<T> item = new DataItem<>(DATA_TYPES.getInt(valueClass), id, value);
             itemsById.put(id, item);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index c4cd9da6a..71a31876d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
@@ -27,7 +29,7 @@ public class TerrainGeneratorNether
     private Biome lastBiomePosX = null;
     private Biome lastBiomeNegZ = null;
     private Biome lastBiomePosZ = null;
-    private Map<Biome, Integer> fluidLookup = new HashMap<>();
+    private Object2IntMap<Biome> fluidLookup = new Object2IntArrayMap<>();
     private int lastChunkX = Integer.MIN_VALUE;
     private int lastChunkZ = Integer.MIN_VALUE;
     private final @NotNull PerlinNoise noise = new PerlinNoise(0L, 4, 0);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
index b73382f39..0519e1427 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.generate.feature;
 
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
@@ -13,7 +14,7 @@ public class WorldFeatureOre extends WorldFeature
 {
     private int minableBlockId;
     private int numberOfBlocks;
-    private final OreMap variantMap;
+    private final Int2IntArrayMap variantMap;
     @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks"})
     public WorldFeatureOre(int blockId, int numberOfBlocks)
     {
@@ -22,7 +23,7 @@ public class WorldFeatureOre extends WorldFeature
         this.variantMap = null;
     }
     @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks", "variantMap"})
-    public WorldFeatureOre(@NotNull OreMap variantMap, int numberOfBlocks)
+    public WorldFeatureOre(@NotNull Int2IntArrayMap variantMap, int numberOfBlocks)
     {
         this.numberOfBlocks = numberOfBlocks;
         this.variantMap = variantMap;
@@ -100,62 +101,4 @@ public class WorldFeatureOre extends WorldFeature
 
         return true;
     }
-
-    // Oremap class, created to quickly map ints to ints without having convert them to Integer Objects, size increasing performance isn't too good and should really only be used in cases where a map is created once then almost never expanded
-    public static class OreMap {
-        private int @NotNull [] keyArr = new int[0];
-        private int @NotNull [] valArr = new int[0];
-
-        private static int @NotNull [] increaseArraySize(final int @NotNull [] array) {
-            final int[] outArr = new int[array.length + 1];
-            System.arraycopy(array, 0, outArr, 0, array.length);
-            return outArr;
-        }
-
-
-        public void put(@NotNull final Block<?> stone, @NotNull final Block<?> ore) {
-            put(stone.id(), ore.id());
-        }
-
-        public void put(final int stoneId, final int oreId) {
-            final int index = indexForKey(stoneId);
-            if (index == -1) {
-                this.keyArr = increaseArraySize(this.keyArr);
-                this.keyArr[this.keyArr.length - 1] = stoneId;
-
-                this.valArr = increaseArraySize(this.valArr);
-                this.valArr[this.valArr.length - 1] = oreId;
-            } else {
-                this.valArr[index] = oreId;
-            }
-        }
-
-        public int get(@NotNull final Block<?> stone) {
-            return get(stone.id());
-        }
-
-        public int get(final int stoneId) {
-            final int index = indexForKey(stoneId);
-            if (index == -1) return index;
-            return this.valArr[index];
-        }
-
-        private int indexForKey(final int stoneId) {
-            for (int i = 0; i < this.keyArr.length; i++) {
-                if (this.keyArr[i] == stoneId) return i;
-            }
-            return -1;
-        }
-
-        public boolean containsKey(@NotNull final Block<?> stone) {
-            return containsKey(stone.id());
-        }
-
-        public boolean containsKey(final int stoneId) {
-            for (int i = 0; i < this.keyArr.length; i++) {
-                if (this.keyArr[i] == stoneId) return true;
-            }
-            return false;
-        }
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
index 4794f7030..5fcb34792 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
@@ -1,5 +1,9 @@
 package net.minecraft.core.world.generate.feature.tree;
 
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+import it.unimi.dsi.fastutil.ints.IntArraySet;
+import it.unimi.dsi.fastutil.ints.IntList;
+import it.unimi.dsi.fastutil.ints.IntSet;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFlower;
 import net.minecraft.core.block.BlockLogicLeavesBase;
@@ -52,8 +56,8 @@ public class WorldFeatureTreePalm extends WorldFeature {
 	
 	protected int logHeight;
 	
-	protected Set<Integer> intSet = new HashSet<>();
-	protected List<Integer> intList = new ArrayList<>();
+	protected IntSet intSet = new IntArraySet();
+	protected IntList intList = new IntArrayList();
 	@MethodParametersAnnotation(names = {"log", "leaves", "big", "update"})
 	public WorldFeatureTreePalm(Block<?> log, Block<?> leaves, boolean big, boolean update, boolean checkForWater) {
 		this.log = log;
@@ -125,7 +129,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		// Check if any blocks are in the way
 		int lastPossibleBlockIndex = intList.size() - 1;
 		for(int i=0; i < intList.size(); i++) {
-			int offset = intList.get(i);
+			int offset = intList.getInt(i);
 			int x = basePos.x + decodeX(offset);
 			int y = basePos.y + decodeY(offset);
 			int z = basePos.z + decodeZ(offset);
@@ -137,7 +141,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		}
 		
 		for(int i = lastPossibleBlockIndex; i >= 0; i--) {
-			int offset = intList.get(i);
+			int offset = intList.getInt(i);
 			int x = basePos.x + decodeX(offset);
 			int y = basePos.y + decodeY(offset);
 			int z = basePos.z + decodeZ(offset);
@@ -158,7 +162,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		int z = 0;
 		logHeight = lastPossibleBlockIndex + 1;
 		for(int i=0; i < logHeight; i++) {
-			int offset = intList.get(i);
+			int offset = intList.getInt(i);
 			x = basePos.x + decodeX(offset);
 			y = basePos.y + decodeY(offset);
 			z = basePos.z + decodeZ(offset);
@@ -234,7 +238,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 			createHorizontalLine(angle, leafLength);
 			
 			for(int j=0; j < intList.size(); j++) {
-				int xyz = intList.get(j);
+				int xyz = intList.getInt(j);
 				
 				int x = this.endPos.x + decodeX(xyz);
 				int y = this.endPos.y;
@@ -259,7 +263,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 			createHorizontalLine(angle, leafLength);
 			
 			for(int j=0; j < intList.size(); j++) {
-				int xyz = intList.get(j);
+				int xyz = intList.getInt(j);
 				
 				int x = this.endPos.x + decodeX(xyz);
 				int y = this.endPos.y;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
index bc326c589..09110cadb 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
@@ -12,7 +13,7 @@ import java.util.Random;
 
 public abstract class WorldFeatureSpoonerTree
     extends WorldFeature {
-    protected static int distToMat(double[] coord, double[] vec, List<Integer> matidxlist, World world, boolean invert, double limit) {
+    protected static int distToMat(double[] coord, double[] vec, IntList matidxlist, World world, boolean invert, double limit) {
         /* travel from cord along vec and return how far it was to a point of matidx
          *
          * the distance is returned in number of iterations. If the edge of the map
diff --git a/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
index ce5c8da06..c889e23fb 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
@@ -1,11 +1,14 @@
 package net.minecraft.core.world.pathfinder;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectLinkedOpenHashMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
@@ -14,13 +17,13 @@ public class PathFinder
 {
     private final WorldSource worldSource;
     private final BinaryHeap openSet;
-    private final IntHashMap<Node> closedSet;
+    private final Int2ObjectMap<Node> closedSet;
     private final Node[] neighbors;
 
     public PathFinder(WorldSource worldSource)
     {
         openSet = new BinaryHeap();
-        closedSet = new IntHashMap<>();
+        closedSet = new Int2ObjectOpenHashMap<>();
         neighbors = new Node[32];
         this.worldSource = worldSource;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFile.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFile.java
index 25407b560..55deba72b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFile.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFile.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.save;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -10,7 +11,7 @@ public class SaveFile
     implements Comparable<SaveFile>
 {
 
-    public SaveFile(@NotNull String fileName, @NotNull String displayName, @Nullable LevelData levelData, @NotNull Map<Integer, DimensionData> dimensionData, long lastTimePlayed, long sizeOnDisk, boolean needsConversion)
+    public SaveFile(@NotNull String fileName, @NotNull String displayName, @Nullable LevelData levelData, @NotNull Int2ObjectMap<DimensionData> dimensionData, long lastTimePlayed, long sizeOnDisk, boolean needsConversion)
     {
         this.fileName = Objects.requireNonNull(fileName);
         this.displayName = Objects.requireNonNull(displayName);
@@ -38,7 +39,7 @@ public class SaveFile
     	return levelData;
     }
     @NotNull
-    public Map<Integer, DimensionData> getDimensionData()
+    public Int2ObjectMap<DimensionData> getDimensionData()
     {
         return dimensionData;
     }
@@ -88,7 +89,7 @@ public class SaveFile
     private final String displayName;
     @Nullable
     private final LevelData levelData;
-    private final @NotNull Map<Integer, DimensionData> dimensionData;
+    private final @NotNull Int2ObjectMap<DimensionData> dimensionData;
     private final long lastTimePlayed;
     private final long sizeOnDisk;
     private final boolean needsConversion;
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
index e1c6a2cf4..0e29802b1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.world.save;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
@@ -147,7 +149,7 @@ public abstract class SaveFormatBase
                 String worldName;
                 long lastTimePlayed;
                 long size;
-                Map<Integer, DimensionData> dimensionData = new HashMap<>();
+                Int2ObjectMap<DimensionData> dimensionData = new Int2ObjectArrayMap<>();
                 boolean needsConversion = false;
                 if (levelData == null) {
                     worldName = I18n.getInstance().translateKey("save.data.missing.data");
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java
index 79e6709e5..7d219878b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormats.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.world.save;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.world.save.legacy.SaveFormatLegacy;
 import net.minecraft.core.world.save.mcregion.SaveFormat19132;
 import net.minecraft.core.world.save.mcregion.SaveFormat19133;
@@ -14,26 +16,21 @@ import java.util.Map;
 public class SaveFormats
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-    public static Map<Integer, Class<? extends ISaveFormat>> saveFormats;
+    public static final Int2ObjectMap<Class<? extends ISaveFormat>> saveFormats = new Int2ObjectArrayMap<>();
 
-    public static ISaveFormat createSaveFormat(int version, File savesDir)
-    {
+    public static ISaveFormat createSaveFormat(final int version, final File savesDir) {
         if (!saveFormats.containsKey(version)) return null;
 
-        try
-        {
+        try {
             return saveFormats.get(version).getConstructor(File.class).newInstance(savesDir);
         }
-        catch (Exception e)
-        {
+        catch (final Exception e) {
             LOGGER.error("Exception instancing ISaveFormat from '{}'!", version, e);
             return null;
         }
     }
 
-    static
-    {
-        saveFormats = new HashMap<>();
+    static {
         saveFormats.put(0, SaveFormatLegacy.class);
         saveFormats.put(19132, SaveFormat19132.class);
         saveFormats.put(19133, SaveFormat19133.class);
diff --git a/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java b/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
index 0116f218e..f2bb30c14 100644
--- a/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
+++ b/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
@@ -5,6 +5,8 @@ import com.mojang.nbt.tags.Tag;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ShortTag;
 import com.mojang.nbt.NbtIo;
+import it.unimi.dsi.fastutil.objects.Object2ShortMap;
+import it.unimi.dsi.fastutil.objects.Object2ShortOpenHashMap;
 import net.minecraft.core.world.save.LevelStorage;
 import org.slf4j.Logger;
 
@@ -18,13 +20,13 @@ public class SavedDataStorage
     private final LevelStorage storage;
     private final Map<Serializable, SavedData> cache;
     private final List<SavedData> loadedData;
-    private final Map<String, Short> idCounts;
+    private final Object2ShortMap<String> idCounts;
 
     public SavedDataStorage(LevelStorage storage)
     {
         cache = new HashMap<>();
         loadedData = new ArrayList<>();
-        idCounts = new HashMap<>();
+        idCounts = new Object2ShortOpenHashMap<>();
         this.storage = storage;
         loadMetadata();
     }
@@ -156,15 +158,7 @@ public class SavedDataStorage
 
     public int getFreeMetadataFor(String type)
     {
-        Short metadata = idCounts.get(type);
-        if(metadata == null)
-        {
-            metadata = (short) 0;
-        }
-        else
-        {
-            metadata = (short) (metadata + 1);
-        }
+        short metadata = (short) (idCounts.getOrDefault(type, (short) -1) + 1);
         idCounts.put(type, metadata);
         if(storage == null)
         {
@@ -178,7 +172,7 @@ public class SavedDataStorage
                 CompoundTag tag = new CompoundTag();
                 for (String dataType : idCounts.keySet())
                 {
-                    short count = idCounts.get(dataType);
+                    short count = idCounts.getShort(dataType);
                     tag.putShort(dataType, count);
                 }
 
diff --git a/game/server/build.gradle.kts b/game/server/build.gradle.kts
index 212354ef1..213aeba0d 100644
--- a/game/server/build.gradle.kts
+++ b/game/server/build.gradle.kts
@@ -23,6 +23,7 @@ dependencies {
 
     // <core dependencies>
     implementation(libs.jetbrains.annotations)?.let { include(it) }
+    implementation(libs.fastutil)?.let { include(it) }
     implementation(libs.gson)?.let { include(it) }
     implementation(libs.brigadier)?.let { include(it) }
     implementation(libs.bundles.log4j)?.let { include(it) }
